#!/bin/bash
# SPDX-Version: 3.0
# SPDX-CreationInfo: 2025-06-17; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-ExternalRef: GIT https://git.coresecret.dev/msw/CISS.debian.installer.git
# SPDX-FileContributor: WEIDNER, Marc S.; Centurion Intelligence Consulting Agency
# SPDX-FileCopyrightText: 2024-2025; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-FileType: SOURCE
# SPDX-License-Identifier: EUPL-1.2 OR LicenseRef-CCLA-1.0
# SPDX-LicenseComment: This file is part of the CISS.debian.installer.secure framework.
# SPDX-PackageName: CISS.debian.installer
# SPDX-Security-Contact: security@coresecret.eu

guard_sourcing

#######################################
# Unbound Variable Check.
# Globals:
#   ERR_UNBOUND_VARIABLE
#   GRE
#   NL
#   RED
#   RES
# Arguments:
#   1: VAR_NAME to check NOT the variable itself.
# Returns:
#   ERR_UNBOUND_VARIABLE
#######################################
check_var() {
  declare var_name_to_check="$1"

  ### First check: Is the passed-in variable name itself set?
  if ! [[ -v var_name_to_check ]]; then
    printf "%b❌ Error: Variable NOT set: '%s'. Exiting Script. %b%b" "${RED}" "${var_name_to_check}" "${RES}" "${NL}" >&2
    return "${ERR_UNBOUND_VARIABLE}"
  fi

  ### Second check: Is the variable referenced by var_name_to_check declared?
  if [[ -v "${var_name_to_check}" ]]; then
    if [[ -n "${!var_name_to_check}" ]]; then
      printf "%b✅ Variable: '%s' exists and is NOT empty: '%s'. %b%b" "${GRE}" "${var_name_to_check}" "${!var_name_to_check}" "${RES}" "${NL}"
    else
      printf "%b✅ Variable: '%s' exists but is empty. %b%b" "${GRE}" "${var_name_to_check}" "${RES}" "${NL}"
    fi
  else
    printf "%b❌ Error: Variable NOT declared: '%s'. Exiting Script. %b%b" "${RED}" "${var_name_to_check}" "${RES}" "${NL}" >&2
    return "${ERR_UNBOUND_VARIABLE}"
  fi
}
# vim: number et ts=2 sw=2 sts=2 ai tw=128 ft=sh
